<div class="container">
  <h2 class="text-center">Reclamos</h2>
  <div class="row">
    <!-- Button trigger modal -->
    <button
      type="button"
      class="btn btn-outline-danger col-12 col-sm-6 col-lg-4 col-xl-2"
      (click)="filtrarClose()"
    >
      Cerrados <i class="pi pi-sliders-h"></i>
    </button>
    <button
      type="button"
      class="btn btn-outline-primary col-12 col-sm-6 col-lg-4 col-xl-2"
      (click)="filtrarOpen()"
    >
      Abierto <i class="pi pi-sliders-h"></i>
    </button>
    <button
      type="button"
      class="btn btn-outline-warning col-12 col-sm-6 col-lg-4 col-xl-2"
      (click)="filtrarPendiente()"
    >
      Pendiente <i class="pi pi-sliders-h"></i>
    </button>
    <button
      type="button"
      class="btn btn-outline-danger col-12 col-sm-6 col-lg-4 col-xl-2"
      data-bs-toggle="modal"
      data-bs-target="#IncidenciaModal"
    >
      Nuevo <i class="pi pi-plus"></i>
    </button>

    <!-- Modal -->
    <div
      class="modal fade"
      id="IncidenciaModal"
      tabindex="-1"
      aria-labelledby="ReclamoModal"
      aria-hidden="true"
    >
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="ReclamoModal">Nuevo Reclamo</h5>
            <button
              type="button"
              class="btn-close"
              data-bs-dismiss="modal"
              aria-label="Close"
            ></button>
          </div>
          <div class="modal-body">
            <form
              [formGroup]="formReclamo"
              (ngSubmit)="enviarData()"
              class="row"
            >
              <div class="col-4"><strong>Fecha</strong></div>
              <div class="col-4"><strong>Terminal</strong></div>
              <div class="col-4">
                <strong> Agente</strong>
              </div>
              <div class="col-4">
                <!-- Fecha -->
                <input
                  type="date"
                  class="form-control"
                  formControlName="date"
                />
              </div>
              <div class="col-4">
                <!-- Terminal -->
                <select formControlName="terminal" class="form-select">
                  <option value="a13491">a13491</option>
                  <option value="a07929">a07929</option>
                  <option value="364">364</option>
                </select>
              </div>
              <div class="col-4">
                <!-- Agente -->
                <!--                 <input
                  class="form-control"
                  type="text"
                  formControlName="agente"
                /> -->
                <select
                  name=""
                  id=""
                  class="form-select"
                  formControlName="agente"
                >
                  <option value="Martin">Martin</option>
                  <option value="Franco">Franco</option>
                  <option value="Nicolas">Nicolas</option>
                </select>
              </div>
              <div class="col-6">
                <label for="">Numero</label>
                <input
                  class="form-control"
                  type="text"
                  formControlName="reclamo"
                  placeholder="RCL XXXX"
                />
              </div>
              <div class="col-12">
                <label for="">Observaciones</label>
                <textarea
                  type="text"
                  class="form-control"
                  formControlName="observations"
                  rows="3"
                  placeholder="Detalle brevemente el reclamo"
                ></textarea>
              </div>

              <div class="col-12">
                <label for="">solucion</label>
                <textarea
                  class="form-control"
                  type="text"
                  formControlName="solucion"
                  rows="3"
                ></textarea>
              </div>
              <div class="col-12">
                <button
                  class="btn btn-outline-danger"
                  [disabled]="formReclamo.invalid"
                >
                  Enviar
                </button>
                <!--                 <button type="button" class="btn btn-primary">
                  Save changes
                </button> -->
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>

    <div class="col-12 border mt-1 bt-1 border-1 border-aqua">
      <div>
        <h3 class="d-flex justify-content-center">Registro de Reclamos</h3>
        <div *ngIf="data2; else errorblock" class="row">
          <div *ngFor="let data of data2; let i = index" class="card mx-1 my-2">
            <div class="card-header row bg-custom">
              <div class="col-6 col-sm-4 col-md-3">
                {{ data.reclamo | uppercase }}
              </div>
              <div class="col-6 col-sm-4 col-md-3">
                {{ data.date | date: "dd/MM/yy" }}
              </div>
              <div class="col-6 col-sm-4 col-md-3">
                {{ data.terminal | uppercase }}
              </div>
              <div class="col-6 col-sm-4 col-md-3">
                <span
                  error-msg
                  color="blue"
                  mensaje="{{ data.state }}"
                  class="badge"
                  >{{ data.state | Estado }}</span
                >
              </div>
            </div>
            <div class="card body row">
              <div class="col-12">Agente = {{ data.agente }}</div>
              <div class="col-12">Detalles: {{ data.observations }}</div>
              <div class="col-12">Solucion: {{ data.solucion }}</div>
              <div class="col-12 d-flex justify-content-end mb-1">
                <button
                  type="button"
                  class="btn btn-outline-info"
                  data-bs-toggle="modal"
                  [attr.data-bs-target]="'#EditModal' + data.reclamo"
                >
                  <i class="pi pi-pencil"> Editar</i>
                </button>
                <button
                  type="button"
                  class="btn btn-outline-danger"
                  data-bs-toggle="modal"
                  [attr.data-bs-target]="'#modal' + data.reclamo"
                >
                  <i class="pi pi-times"> Eliminar</i>
                </button>
              </div>
            </div>
            <!-- Modal Eliminar -->
            <div
              class="modal fade"
              tabindex="-1"
              id="modal{{ data.reclamo }}"
              aria-labelledby="modal{{data.reclamo}+ok}"
            >
              <div class="modal-dialog">
                <div class="modal-content">
                  <div class="modal-header">
                    <h5 class="modal-title" id="modal{{data.reclamo}+ok">
                      Eliminar Reclamo
                    </h5>
                    <button
                      type="button"
                      class="btn-close"
                      data-bs-dismiss="modal"
                      aria-label="Close"
                    ></button>
                  </div>
                  <div class="modal-body">
                    <p>¿Desea Eliminar Este Reclamo?</p>
                  </div>
                  <div class="modal-footer">
                    <button
                      type="button"
                      class="btn btn-secondary"
                      data-bs-dismiss="modal"
                    >
                      Cancelar
                    </button>
                    <button
                      (click)="eliminarRegistro(data._id,'modal{{ data.reclamo }}')"
                      type="button"
                      class="btn btn-danger"
                    >
                      Eliminar <br />
                    </button>
                  </div>
                </div>
              </div>
            </div>
            <!-- End Modal -->
            <!-- Modal Editar  -->
            <div
              class="modal fade"
              id="EditModal{{ data.reclamo }}"
              tabindex="-1"
              aria-labelledby="EditModal{{data.reclamo}+ok}"
            >
              <div class="modal-dialog">
                <div class="modal-content">
                  <div class="modal-header">
                    <h5 class="modal-title" id="modal{{ data.reclamo }}ok">
                      Editar
                    </h5>
                    <button
                      type="button"
                      class="btn-close"
                      data-bs-dismiss="modal"
                      aria-label="Close"
                    ></button>
                  </div>
                  <div class="modal-body">
                    <form class="row">
                      <div class="col-4">
                        <strong>Fecha: </strong
                        >{{ data.date | date: "dd/MM/yy" }}
                      </div>
                      <div class="col-4">
                        <strong>Terminal: </strong>{{ data.terminal }}
                      </div>
                      <div class="col-4">
                        <strong> Agente: </strong>{{ data.agente }}
                      </div>

                      <div class="col-12">
                        <label for="">Observaciones</label>
                        <textarea
                          type="text"
                          class="form-control {{ i }}"
                          rows="3"
                          id="{{ i }}observaciones"
                          >{{ data.observations }}</textarea
                        >
                      </div>
                      <div class="col-12">
                        <label for="">solucion</label>
                        <textarea
                          class="form-control {{ i }}"
                          type="text"
                          rows="3"
                          id="{{ i }}solucion"
                          >{{ data.solucion }}</textarea
                        >
                      </div>
                      <div class="col-4">
                        <label for="">Estado</label>
                        <select
                          value=""
                          id="{{ i }}select"
                          class="form-control"
                        >
                          <option value="open">Abierto</option>
                          <option value="current">Revision</option>
                          <option value="close">Cerrado</option>
                        </select>
                      </div>
                      <div class="col-12">
                        <button
                          (click)="putData(i, data._id)"
                          class="btn btn-outline-danger"
                          type="button"
                        >
                          Enviar
                        </button>
                      </div>
                    </form>
                  </div>
                </div>
              </div>
            </div>
            <!-- END Modal Editar  -->
          </div>
          <button class="btn btn-info" (click)="downloadFile(data2)">
            Exportar a CSV
          </button>
        </div>

        <ng-template #errorblock>
          <div class="alert alert-danger">Error en la coneccion de la DB</div>
        </ng-template>
      </div>
    </div>
  </div>
</div>
